package com.maroontress.madangler.client.config;

import com.google.gwt.user.client.ui.CheckBox;
import com.google.gwt.user.client.ui.ClickListener;
import com.google.gwt.user.client.ui.DockPanel;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.Widget;
import java.util.ArrayList;

/**
   ᡼ΥѥͥǤ
*/
public class MailPanel extends DockPanel {

    /** ƥȥܥå */
    private ArrayList<ConfigTextPanel> boxes;

    /** ᡼Τ̵ͭΥåܥå */
    private CheckBox enables;

    /** SMTP */
    private ConfigTextPanel smtpServer;

    /** Τ᡼륢ɥ쥹 */
    private ConfigTextPanel receipient;

    /** Τ긵ˤʤ᡼륢ɥ쥹 */
    private ConfigTextPanel sender;

    /**
       ᡼Υѥͥޤ

       @param model ץΥǥ
    */
    public MailPanel(final ConfigModel model) {
	model.addChangedListener(new ChangedListener() {
	    public void propertyChanged(final ConfigModel model) {
		boolean b = !model.getProperty("mailEnabled").equals("0");
		enables.setChecked(b);
		setTextEnabled(b);
		smtpServer.setText(model.getProperty("smtpServer"));
		sender.setText(model.getProperty("sender"));
		receipient.setText(model.getProperty("receipient"));
	    }
	});

	enables = new CheckBox("Enable sending mails");
	enables.addClickListener(new ClickListener() {
	    public void onClick(final Widget sender) {
		boolean b = enables.isChecked();
		setTextEnabled(b);
		model.setProperty("mailEnabled", b ? "1" : "0");
	    }
	});
	smtpServer = new ConfigTextPanel("SMTP Server", 64,
					 model, "smtpServer");
	sender = new ConfigTextPanel("Sender (From)", 64, model, "sender");
	receipient = new ConfigTextPanel("Receipient (To)", 64,
					 model, "receipient");

	VerticalPanel vp = new VerticalPanel();
	vp.add(enables);
	// vp.add(new HTML("&nbsp;"));
	vp.add(smtpServer);
	vp.add(new HTML("&nbsp;"));
	vp.add(sender);
	vp.add(new HTML("&nbsp;"));
	vp.add(receipient);
	add(vp, DockPanel.NORTH);
	add(new HTML("&nbsp;"), DockPanel.CENTER);

	boxes = new ArrayList<ConfigTextPanel>();
	boxes.add(smtpServer);
	boxes.add(sender);
	boxes.add(receipient);

	// ΤȤۥȤmailȤ...
	smtpServer.setVisible(false);
    }

    /**
       ƥȥܥåǽԲĤꤷޤ

       @param enabled trueξǽfalseξԲ
    */
    private void setTextEnabled(final boolean enabled) {
	for (int k = 0; k < boxes.size(); ++k) {
            ConfigTextPanel box = boxes.get(k);
            box.setEnabled(enabled);
        }
    }
}
